
/** TP 5ETI - CPE Lyon - 2012/2013 */


#include <scene.hpp>

#include <GL/glew.h>
#include <QString>
#include <QFont>
#include <glwidget.hpp>


#include <opengl_drawer.hpp>
#include <perlin.hpp>
#include <cmath>
#include <debug_mesh.hpp>

#include <assert.h>

using namespace cpe;



void scene::load_model()
{
    assert(p_widget!=NULL);
    assert(p_debug_mesh!=NULL);


    //*****************************************//
    // Generate mesh                           //
    //*****************************************//
    mesh_0.add_vertex(v3(0,0,0));
    mesh_0.add_vertex(v3(1,0,0.2));
    mesh_0.add_vertex(v3(2,0,0));
    mesh_0.add_vertex(v3(0,1,0));
    mesh_0.add_vertex(v3(1,1,0.2));
    mesh_0.add_vertex(v3(2,1,0));


    mesh_0.add_texture(v2(0.0,0));
    mesh_0.add_texture(v2(0.5,0));
    mesh_0.add_texture(v2(1.0,0));
    mesh_0.add_texture(v2(0.0,1));
    mesh_0.add_texture(v2(0.5,1));
    mesh_0.add_texture(v2(1.0,1));

    mesh_0.add_triangle(0,1,4);
    mesh_0.add_triangle(0,4,3);
    mesh_0.add_triangle(1,2,5);
    mesh_0.add_triangle(1,5,4);

    mesh_0.compute_normal();
    mesh_0.fill_color_xyz();

    const std::string texture_path="data/seamless_grass_texture.png";
    texture_id_0=0;
    texture_id_0=p_widget->bindTexture(QString(texture_path.c_str()),GL_TEXTURE_2D);
    if(texture_id_0==0)
        std::cout<<"Erreur chargement texture "<<texture_path<<std::endl;

    //*****************************************//
    // \Generate mesh                           //
    //*****************************************//
}

void scene::draw_scene()
{
    glEnable(GL_LIGHTING);
    glEnable(GL_TEXTURE_2D);

    glColor3d(1,1,1);

    //draw mesh
    glBindTexture(GL_TEXTURE_2D,texture_id_0);
    cpe::opengl_drawer::draw(mesh_0);


    //draw debug information if asked in the GUI
    p_debug_mesh->draw_debug(mesh_0);

}





scene::scene()
{

    p_widget=NULL;
    p_debug_mesh=NULL;

    texture_id_0=0;
}


void scene::set_glwidget(glwidget *p_widget_)
{
    p_widget=p_widget_;
}
void scene::set_debug_mesh(cpe::debug_mesh *p_debug_mesh_)
{
    p_debug_mesh=p_debug_mesh_;
}

